package org.informatika.ojek;

import com.google.gson.Gson;
import org.informatika.ojek.model.Account;
import org.informatika.ojek.model.AccountDAO;
import org.informatika.ojek.model.Response;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.SQLException;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import static jdk.nashorn.internal.runtime.regexp.joni.Config.log;

/**
 *
 * @author fadhilimamk
 */
@WebServlet(name = "Auth", urlPatterns = {"/auth"})
public class Auth extends HttpServlet {

    private AccountDAO accountDAO;

    public void init() {
        String jdbcURL = getServletContext().getInitParameter("jdbcURL");
        String jdbcUsername = getServletContext().getInitParameter("jdbcUsername");
        String jdbcPassword = getServletContext().getInitParameter("jdbcPassword");

        accountDAO = new AccountDAO(jdbcURL, jdbcUsername, jdbcPassword);
    }

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        response.setStatus(200);
        
        PrintWriter out = response.getWriter();
        
        String username = request.getParameter("username");
        String password = request.getParameter("password");
        
        Gson gson = new Gson();
        Response data;
        String dataResponse;
        
        if (username == null || password == null) {
            response.setStatus(500);
            data = new Response("error", null,  null, "Wrong parameter!");
        } else {
            int isAvailable = -1;

            isAvailable = accountDAO.checkAvailability(username, password);

            if (isAvailable != -1) {
                String token= null;
                try {
                    token = Account.generateToken(isAvailable, username, password);
                    accountDAO.saveToken(isAvailable, token);
                } catch (Exception e) {
                    throw new ServletException(e);
                }
                data = new Response("success", token, null, null);
            } else {
                response.setStatus(500);
                data = new Response("error", null, null, "Wrong username or password!");
            }

        }
        
        dataResponse = gson.toJson(data);
        out.print(dataResponse);
    }

}
